您的位置:首页 > 其它

Codeforces Round #370 (Div. 2) D. Memory and Scores

2016-09-13 19:20 471 查看
D. Memory and Scores

time limit per test
2 seconds

memory limit per test
512 megabytes

input
standard input

output
standard output

Memory and his friend Lexa are competing to get higher score in one popular computer game. Memory starts with score
a and Lexa starts with score
b. In a single turn, both Memory and Lexa get some integer in the range
[ - k;k] (i.e. one integer among
 - k,  - k + 1,  - k + 2, ...,  - 2,  - 1, 0, 1, 2, ..., k - 1, k) and add them to their current scores. The game has exactly
t turns. Memory and Lexa, however, are not good at this game, so they both always get a random integer at their turn.

Memory wonders how many possible games exist such that he ends with a strictly higher score than Lexa. Two games are considered to be different if in at least one turn at least one player gets different score. There are
(2k + 1)2t games in total. Since the answer can be very large, you should print it modulo
109 + 7. Please solve this problem for Memory.

Input
The first and only line of input contains the four integers
a, b,
k, and t (1 ≤ a, b ≤ 100,
1 ≤ k ≤ 1000, 1 ≤ t ≤ 100) — the amount Memory and Lexa start with, the number
k, and the number of turns respectively.

Output
Print the number of possible games satisfying the conditions modulo
1 000 000 007 (109 + 7) in one line.

Examples

Input
1 2 2 1


Output
6


Input
1 1 1 2


Output
31


Input
2 12 3 1


Output
0


Note
In the first sample test, Memory starts with 1 and Lexa starts with
2. If Lexa picks  - 2, Memory can pick
0, 1, or
2 to win. If Lexa picks  - 1, Memory can pick
1 or 2 to win. If Lexa picks
0, Memory can pick 2 to win. If Lexa picks
1 or 2, Memory cannot win. Thus, there are
3 + 2 + 1 = 6 possible games in which Memory wins.

【题意】有两个人在玩游戏,一开始分数分别为a和b,每一局,每个人可以获得分数[-k,k]之间,问你A胜过B的方案数有多少种?

【解题方法】dp[i][j]代表第i轮得分为j的方案,显然这个状态只会和上一次游戏有关,因此这里可以用前缀和来优化这个转移。

【时间复杂度】O(k*t)

【AC 代码】

//
//Created by just_sort 2016/9/13 18:42
//Copyright (c) 2016 just_sort.All Rights Reserved
//

#include <set>
#include <map>
#include <queue>
#include <stack>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;
typedef long long LL;
const int maxn = 210010;
const int mod = 1e9+7;
int dp[110][maxn],sum[maxn];//dp[i][j]代表第i轮得分为j的方案数
int a,b,k,t;

int main()
{
scanf("%d%d%d%d",&a,&b,&k,&t);
dp[0][0] = 1;
for(int i=1; i<=t; i++){
for(int j=0; j<maxn; j++) sum[j] = ((j>0?sum[j-1]:0) + dp[i-1][j])%mod;
for(int j=0; j<maxn; j++) dp[i][j] = (sum[j]-(j-2*k-1>=0?sum[j-2*k-1]:0) + mod)%mod;
}
for(int i=0; i<maxn; i++){
sum[i] = ((i>0?sum[i-1]:0) + dp[t][i])%mod;
}
//枚举a的得分
int ans = 0;
for(int i=0; i<=2*k*t; i++){
(ans += (1LL)*dp[t][i]*(i+a-b-1<0?0:sum[i+a-b-1])%mod) %= mod;
}
printf("%d\n",ans);
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: